'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _babelTypes = require('babel-types');

var _babylon = require('babylon');

var _graphqlTag = require('graphql-tag');

var _graphqlTag2 = _interopRequireDefault(_graphqlTag);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = () => {
  const compile = node => {
    const source = node.quasis.reduce((head, quasi) => {
      return head + quasi.value.raw;
    }, '');

    return (0, _babylon.parse)(JSON.stringify([(0, _graphqlTag2.default)(source)])).program.body[0].expression.elements[0];
  };

  return {
    visitor: {
      ImportDeclaration(path) {
        if (path.node.source.value === 'graphql-tag') {
          path.remove();
        }
      },
      TaggedTemplateExpression(path) {
        if ((0, _babelTypes.isIdentifier)(path.node.tag, {
          name: 'gql'
        })) {
          path.replaceWith(compile(path.node.quasi));
        }
      }
    }
  };
};
//# sourceMappingURL=index.js.map